Index: trunk/gui/scripts/gauge.tcl
===================================================================
--- trunk/gui/scripts/gauge.tcl	(revision 6716)
+++ trunk/gui/scripts/gauge.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: gauge - compact readout for real values
@@ -10,16 +9,11 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
 package require BLT
 
-option add *Gauge.sampleWidth 30 widgetDefault
-option add *Gauge.sampleHeight 20 widgetDefault
-option add *Gauge.borderWidth 2 widgetDefault
-option add *Gauge.relief sunken widgetDefault
+option add *Gauge.width 30 widgetDefault
+option add *Gauge.height 20 widgetDefault
 option add *Gauge.valuePosition "right" widgetDefault
 option add *Gauge.textBackground #cccccc widgetDefault
@@ -30,7 +24,5 @@
 
     itk_option define -editable editable Editable ""
-    itk_option define -state state State "normal"
     itk_option define -spectrum spectrum Spectrum ""
-    itk_option define -type type Type "real"
     itk_option define -units units Units ""
     itk_option define -minvalue minValue MinValue ""
@@ -39,17 +31,10 @@
     itk_option define -valueposition valuePosition ValuePosition ""
     itk_option define -image image Image ""
-    itk_option define -samplewidth sampleWidth SampleWidth 0
-    itk_option define -sampleheight sampleHeight SampleHeight 0
-    itk_option define -log log Log ""
-    itk_option define -varname varname Varname ""
-    itk_option define -label label Label ""
-    itk_option define -validatecommand validateCommand ValidateCommand ""
-    itk_option define -uq uq Uq no
+    itk_option define -width width Width 0
+    itk_option define -height height Height 0
 
     constructor {args} { # defined below }
 
     public method value {args}
-    public method edit {option}
-    public method bump {delta}
 
     protected method _redraw {}
@@ -58,15 +43,6 @@
     protected method _editor {option args}
     protected method _presets {option}
-    protected method _layout {}
-    protected method _log {event args}
-    protected method _change_param_type {choice}
-    protected method _pop_uq {win}
-    protected method _pop_uq_deactivate {}
-
-    private variable _value 0;    # value for this widget
-    private variable _mode exact; # current mode
-    private variable _pde "";     # ProbDistEditor
-    private variable _val "";     # value choice combobox
-    private variable uq no
+
+    private variable _value 0  ;# value for this widget
 
     blt::bitmap define GaugeArrow {
@@ -77,5 +53,5 @@
     }
 }
-
+                                                                                
 itk::usual Gauge {
     keep -cursor -font -foreground -background
@@ -87,47 +63,21 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::constructor {args} {
-    # puts "GAUGE CONS: $args"
-    array set attrs $args
-
-    itk_option remove hull.borderwidth hull.relief
-    component hull configure -borderwidth 0
-
     itk_component add icon {
-        canvas $itk_interior.icon -width 1 -height 1 \
-            -borderwidth 0 -highlightthickness 0
+        canvas $itk_interior.icon -borderwidth 0 -highlightthickness 0
     } {
         usual
         ignore -highlightthickness -highlightbackground -highlightcolor
-        ignore -borderwidth -relief
-    }
+    }
+    pack $itk_component(icon) -side left
     bind $itk_component(icon) <Configure> [itcl::code $this _redraw]
-
-    if {[info exists attrs(-uq)]} {
-        set uq $attrs(-uq)
-        if {[string is true $uq]} {
-            set uq 1
-            itk_component add uq {
-                button $itk_interior.uq -image [Rappture::icon UQ] \
-                    -command [itcl::code $this _pop_uq $itk_interior]
-            }
-            pack $itk_component(uq) -side right -padx 10
-        } else {
-            set uq 0
-        }
-    } else {
-        set uq 0
-    }
 
     itk_component add -protected vframe {
         frame $itk_interior.vframe
+    }
+
+    itk_component add value {
+        label $itk_component(vframe).value -borderwidth 1 -width 7 \
+            -textvariable [itcl::scope _value]
     } {
-        keep -borderwidth -relief
-    }
-
-    itk_component add value {
-        label $itk_component(vframe).value -width 20 \
-            -borderwidth 1 -relief flat -textvariable [itcl::scope _value]
-    } {
-        keep -font
         rename -background -textbackground textBackground Background
     }
@@ -136,23 +86,4 @@
     bind $itk_component(value) <Enter> [itcl::code $this _hilite value on]
     bind $itk_component(value) <Leave> [itcl::code $this _hilite value off]
-
-    bind $itk_component(value) <<Cut>> [itcl::code $this edit cut]
-    bind $itk_component(value) <<Copy>> [itcl::code $this edit copy]
-    bind $itk_component(value) <<Paste>> [itcl::code $this edit paste]
-
-    itk_component add emenu {
-        menu $itk_component(value).menu -tearoff 0
-    } {
-        usual
-        ignore -tearoff
-    }
-    $itk_component(emenu) add command -label "Cut" -accelerator "^X" \
-        -command [list event generate $itk_component(value) <<Cut>>]
-    $itk_component(emenu) add command -label "Copy" -accelerator "^C" \
-        -command [list event generate $itk_component(value) <<Copy>>]
-    $itk_component(emenu) add command -label "Paste" -accelerator "^V" \
-        -command [list event generate $itk_component(value) <<Paste>>]
-    bind $itk_component(value) <<PopupMenu>> \
-        [itcl::code $this _editor menu %X %Y]
 
     itk_component add editor {
@@ -165,37 +96,11 @@
         [itcl::code $this _editor popup]
 
-
-    itk_component add spinner {
-        frame $itk_component(vframe).spinner
-    }
-
-    itk_component add spinup {
-        button $itk_component(spinner).up -image [Rappture::icon intplus] \
-            -borderwidth 1 -relief raised -highlightthickness 0 \
-            -command [itcl::code $this bump 1]
-    } {
-        usual
-        ignore -borderwidth -highlightthickness
-        rename -background -buttonbackground buttonBackground Background
-    }
-    pack $itk_component(spinup) -side left -expand yes -fill both
-
-    itk_component add spindn {
-        button $itk_component(spinner).down -image [Rappture::icon intminus] \
-            -borderwidth 1 -relief raised -highlightthickness 0 \
-            -command [itcl::code $this bump -1]
-    } {
-        usual
-        ignore -borderwidth -highlightthickness
-        rename -background -buttonbackground buttonBackground Background
-    }
-    pack $itk_component(spindn) -side right -expand yes -fill both
-
     itk_component add presets {
         button $itk_component(vframe).psbtn -bitmap GaugeArrow \
-            -borderwidth 1 -highlightthickness 0 -relief raised
+            -borderwidth 1 -highlightthickness 0 -relief flat
     } {
         usual
         ignore -borderwidth -relief -highlightthickness
+        rename -background -textbackground textBackground Background
     }
 
@@ -228,135 +133,54 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::value {args} {
-    #puts "Gauge value: $args"
-
-    # Query.  Just return the current value.
-    if {[llength $args] == 0} {
-        return $_value
-    }
-
+    set onlycheck 0
     set i [lsearch -exact $args -check]
     if {$i >= 0} {
         set onlycheck 1
         set args [lreplace $args $i $i]
-    } else {
-        set onlycheck 0
-    }
-
-    if {[llength $args] != 1} {
+    }
+
+    if {[llength $args] == 1} {
+        #
+        # If this gauge has -units, try to convert the incoming
+        # value to that system of units.  Also, make sure that
+        # the value is bound by any min/max value constraints.
+        #
+        set newval [lindex $args 0]
+        if {$itk_option(-units) != ""} {
+            set units $itk_option(-units)
+            set newval [Rappture::Units::convert $newval -context $units]
+            set nv [Rappture::Units::convert $newval \
+                -context $units -to $units -units off]
+
+            if {"" != $itk_option(-minvalue)} {
+                set minv [Rappture::Units::convert $itk_option(-minvalue) \
+                    -context $units -to $units -units off]
+                if {$nv < $minv} {
+                    error "minimum value allowed here is $itk_option(-minvalue)"
+                }
+            }
+
+            if {"" != $itk_option(-maxvalue)} {
+                set maxv [Rappture::Units::convert $itk_option(-maxvalue) \
+                    -context $units -to $units -units off]
+                if {$nv > $maxv} {
+                    error "maximum value allowed here is $itk_option(-maxvalue)"
+                }
+            }
+        } elseif {![string is double -strict $newval]} {
+            error "Should be a real number"
+        }
+
+        if {$onlycheck} {
+            return
+        }
+        set _value $newval
+        _redraw
+        event generate $itk_component(hull) <<Value>>
+
+    } elseif {[llength $args] != 0} {
         error "wrong # args: should be \"value ?-check? ?newval?\""
     }
-
-    set newval [Rappture::Units::mcheck_range [lindex $args 0] \
-    $itk_option(-minvalue) $itk_option(-maxvalue) $itk_option(-units)]
-
-    set newmode [lindex $newval 0]
-    switch -- $newmode {
-        uniform -
-        gaussian {
-            set _mode $newmode
-        }
-        exact -
-        default {
-            set _mode exact
-        }
-    }
-
-    switch -- $itk_option(-type) {
-        integer {
-            if { [scan $newval "%g" value] != 1 || int($newval) != $value } {
-                error "bad value \"$newval\": should be an integer value"
-            }
-        }
-    }
-
-    #
-    # If there's a -validatecommand option, then invoke the code
-    # now to check the new value.
-    #
-    if {[string length $itk_option(-validatecommand)] > 0} {
-        set cmd "uplevel #0 [list $itk_option(-validatecommand) [list $newval]]"
-        set result [eval $cmd]
-    }
-
-    if {$onlycheck} {
-        return
-    }
-
-    set _value $newval
-    $itk_component(value) configure -width [string length $_value]
-    _redraw
-    event generate $itk_component(hull) <<Value>>
-
-    if {"" != $_pde} {
-        set val [$_val translate [$_val value]]
-        $_val value $_mode
-        $_pde value $_value
-
-    }
     return $_value
-}
-
-# ----------------------------------------------------------------------
-# USAGE: edit cut
-# USAGE: edit copy
-# USAGE: edit paste
-#
-# Used internally to handle cut/copy/paste operations for the current
-# value.  Usually invoked by <<Cut>>, <<Copy>>, <<Paste>> events, but
-# can also be called directly through this method.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Gauge::edit {option} {
-    if {$itk_option(-state) == "disabled"} {
-        return; # disabled? then bail out here!
-    }
-    switch -- $option {
-        cut {
-            edit copy
-            _editor popup
-            $itk_component(editor) value ""
-            $itk_component(editor) deactivate
-        }
-        copy {
-            clipboard clear
-            clipboard append $_value
-        }
-        paste {
-            _editor popup
-            $itk_component(editor) value [clipboard get]
-            $itk_component(editor) deactivate
-        }
-        default {
-            error "bad option \"$option\": should be cut, copy, paste"
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: bump <delta>
-#
-# Changes the current value up/down by the <delta> value.  Used
-# internally by the up/down spinner buttons when the value is
-# -type integer.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Gauge::bump {delta} {
-    set val $_value
-    if {$val == ""} {
-        set val 0
-    }
-    if {[catch {value [expr {$val+$delta}]} result]} {
-        if {[regexp {allowed here is (.+)} $result match newval]} {
-            set _value $newval
-            $itk_component(value) configure -text $newval
-        }
-        if {[regexp {^bad.*: +(.)(.+)} $result match first tail]
-              || [regexp {(.)(.+)} $result match first tail]} {
-            set result "[string toupper $first]$tail"
-        }
-        bell
-        Rappture::Tooltip::cue $itk_component(value) $result
-        _log warning $result
-        return 0
-    }
-    _log input [value]
 }
 
@@ -378,5 +202,4 @@
         $c create rectangle 0 0 1 1 -outline black -tags block
         $c create image 0 0 -anchor center -image "" -tags bimage
-        $c create rectangle 0 0 1 1 -outline "" -fill "" -stipple gray50 -tags screen
     }
 
@@ -389,14 +212,7 @@
     # update the items based on current values
     $c coords block 0 0 [expr {$w-1}] [expr {$h-1}]
-    $c coords screen 0 0 $w $h
     $c itemconfigure block -fill $color
 
     $c coords bimage [expr {0.5*$w}] [expr {0.5*$h}]
-
-    if {$itk_option(-state) == "disabled"} {
-        $c itemconfigure screen -fill white
-    } else {
-        $c itemconfigure screen -fill ""
-    }
 }
 
@@ -408,32 +224,25 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::_resize {} {
-    set w 0
-    set h 0
-
-    if {"" != $itk_option(-image) || "" != $itk_option(-spectrum)} {
-        if {$itk_option(-samplewidth) > 0} {
-            set w $itk_option(-samplewidth)
+    if {$itk_option(-width) > 0} {
+        set w $itk_option(-width)
+    } else {
+        if {$itk_option(-image) != ""} {
+            set w [expr {[image width $itk_option(-image)]+4}]
         } else {
-            if {$itk_option(-image) != ""} {
-                set w [expr {[image width $itk_option(-image)]+4}]
-            } else {
-                set w [winfo reqheight $itk_component(value)]
-            }
-        }
-
-        if {$itk_option(-sampleheight) > 0} {
-            set h $itk_option(-sampleheight)
+            set w [winfo reqheight $itk_component(value)]
+        }
+    }
+
+    if {$itk_option(-height) > 0} {
+        set h $itk_option(-height)
+    } else {
+        if {$itk_option(-image) != ""} {
+            set h [expr {[image height $itk_option(-image)]+4}]
         } else {
-            if {$itk_option(-image) != ""} {
-                set h [expr {[image height $itk_option(-image)]+4}]
-            } else {
-                set h [winfo reqheight $itk_component(value)]
-            }
-        }
-    }
-
-    if {$w > 0 && $h > 0} {
-        $itk_component(icon) configure -width $w -height $h
-    }
+            set h [winfo reqheight $itk_component(value)]
+        }
+    }
+
+    $itk_component(icon) configure -width $w -height $h
 }
 
@@ -445,7 +254,4 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::_hilite {comp state} {
-    if {$itk_option(-state) == "disabled"} {
-        set state 0; # disabled? then don't hilite
-    }
     if {$comp == "value" && !$itk_option(-editable)} {
         $itk_component(value) configure -relief flat
@@ -454,11 +260,7 @@
 
     if {$state} {
+        $itk_component($comp) configure -relief solid
+    } else {
         $itk_component($comp) configure -relief flat
-    } else {
-        if {$comp eq "presets"} {
-            $itk_component($comp) configure -relief raised
-        } else {
-            $itk_component($comp) configure -relief flat
-        }
     }
 }
@@ -469,5 +271,4 @@
 # USAGE: _editor validate <value>
 # USAGE: _editor apply <value>
-# USAGE: _editor menu <rootx> <rooty>
 #
 # Used internally to handle the various functions of the pop-up
@@ -475,8 +276,4 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::_editor {option args} {
-    # puts "Gauge::editor option=$option args=$args"
-    if {$itk_option(-state) == "disabled"} {
-        return; # disabled? then bail out here!
-    }
     switch -- $option {
         popup {
@@ -497,4 +294,5 @@
             }
             set val [lindex $args 0]
+
             if {[catch {value -check $val} result]} {
                 if {[regexp {allowed here is (.+)} $result match newval]} {
@@ -507,5 +305,4 @@
                 bell
                 Rappture::Tooltip::cue $itk_component(editor) $result
-                _log warning $result
                 return 0
             }
@@ -515,13 +312,8 @@
                 error "wrong # args: should be \"_editor apply val\""
             }
-            set newval [lindex $args 0]
-            value $newval
-            _log input $newval
-        }
-        menu {
-            eval tk_popup $itk_component(emenu) $args
+            value [lindex $args 0]
         }
         default {
-            error "bad option \"$option\": should be popup, activate, validate, apply, and menu"
+            error "bad option \"$option\": should be popup, activate, validate, apply"
         }
     }
@@ -550,5 +342,5 @@
         }
         unpost {
-            $itk_component(presets) configure -relief raised
+            $itk_component(presets) configure -relief flat
         }
         select {
@@ -556,5 +348,4 @@
             if {"" != $val} {
                 value $val
-                _log input $val
             }
         }
@@ -566,20 +357,53 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _layout
-#
-# Used internally to fix the layout of widgets whenever there is a
-# change in the options that affect layout.  Puts the value in the
-# proper position according to the -valueposition option.  Also,
-# adds or removes the icon if it needs to be shown.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Gauge::_layout {} {
-    foreach w [pack slaves $itk_component(hull)] {
-        pack forget $w
-    }
-
-    if {$itk_option(-type) != "integer" && $uq} {
-        pack $itk_component(uq) -side right -padx 10
-    }
-
+# CONFIGURATION OPTION: -editable
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::Gauge::editable {
+    if {![string is boolean -strict $itk_option(-editable)]} {
+        error "bad value \"$itk_option(-editable)\": should be boolean"
+    }
+    if {!$itk_option(-editable) && [winfo ismapped $itk_component(editor)]} {
+        $itk_component(editor) deactivate -abort
+    }
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -spectrum
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::Gauge::spectrum {
+    if {$itk_option(-spectrum) != ""
+          && ([catch {$itk_option(-spectrum) isa ::Rappture::Spectrum} valid]
+               || !$valid)} {
+        error "bad option \"$itk_option(-spectrum)\": should be Rappture::Spectrum object"
+    }
+    _redraw
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -image
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::Gauge::image {
+    if {$itk_option(-image) != ""
+          && [catch {image width $itk_option(-image)}]} {
+        error "bad value \"$itk_option(-image)\": should be Tk image"
+    }
+    _resize
+    $itk_component(icon) itemconfigure bimage -image $itk_option(-image)
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -units
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::Gauge::units {
+    if {$itk_option(-units) != ""
+          && [::Rappture::Units::System::for $itk_option(-units)] == ""} {
+        error "unrecognized system of units \"$itk_option(-units)\""
+    }
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -valueposition
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::Gauge::valueposition {
     array set side2anchor {
         left   e
@@ -589,104 +413,10 @@
     }
     set pos $itk_option(-valueposition)
-    pack $itk_component(vframe) -side $pos \
-        -expand yes -fill both -ipadx 2
+    if {![info exists side2anchor($pos)]} {
+        error "bad value \"$pos\": should be [join [lsort [array names side2anchor]] {, }]"
+    }
+    pack $itk_component(vframe) -before $itk_component(icon) \
+        -side $pos -expand yes -fill both -ipadx 2
     $itk_component(value) configure -anchor $side2anchor($pos)
-
-    if {"" != $itk_option(-image) || "" != $itk_option(-spectrum)} {
-        pack $itk_component(icon) -side $pos -padx 2
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _log event ?arg arg...?
-#
-# Used internally to send info to the logging mechanism.  If the -log
-# argument is set, then this calls the Rappture::Logger mechanism to
-# log the rest of the arguments as an action.  Otherwise, it does
-# nothing.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Gauge::_log {event args} {
-    if {$itk_option(-log) ne ""} {
-        eval Rappture::Logger::log $event [list $itk_option(-log)] $args
-    }
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -editable
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::editable {
-    if {![string is boolean -strict $itk_option(-editable)]} {
-        error "bad value \"$itk_option(-editable)\": should be boolean"
-    }
-    if {!$itk_option(-editable) && [winfo ismapped $itk_component(editor)]} {
-        $itk_component(editor) deactivate -abort
-    }
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -state
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::state {
-    set valid {normal disabled}
-    if {[lsearch -exact $valid $itk_option(-state)] < 0} {
-        error "bad value \"$itk_option(-state)\": should be [join $valid {, }]"
-    }
-    $itk_component(value) configure -state $itk_option(-state)
-    $itk_component(spinup) configure -state $itk_option(-state)
-    $itk_component(spindn) configure -state $itk_option(-state)
-    $itk_component(presets) configure -state $itk_option(-state)
-    if { [info exists itk_component(uq)] } {
-        $itk_component(uq) configure -state $itk_option(-state)
-    }
-    _redraw; # fix gauge
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -spectrum
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::spectrum {
-    if {$itk_option(-spectrum) != ""
-          && ([catch {$itk_option(-spectrum) isa ::Rappture::Spectrum} valid]
-               || !$valid)} {
-        error "bad option \"$itk_option(-spectrum)\": should be Rappture::Spectrum object"
-    }
-    _resize
-    _layout
-    _redraw
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -image
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::image {
-    if {$itk_option(-image) != ""
-          && [catch {image width $itk_option(-image)}]} {
-        error "bad value \"$itk_option(-image)\": should be Tk image"
-    }
-    _resize
-    _layout
-    $itk_component(icon) itemconfigure bimage -image $itk_option(-image)
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -units
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::units {
-    if {$itk_option(-units) != ""
-          && [::Rappture::Units::System::for $itk_option(-units)] == ""} {
-        error "unrecognized system of units \"$itk_option(-units)\""
-    }
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -valueposition
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::valueposition {
-    set pos $itk_option(-valueposition)
-    set opts {left right top bottom}
-    if {[lsearch -exact $opts $pos] < 0} {
-        error "bad value \"$pos\": should be [join $opts {, }]"
-    }
-    _layout
 }
 
@@ -703,6 +433,6 @@
             set s "right"
         }
-        set first [lindex [pack slaves $itk_component(vframe)] 0]
-        pack $itk_component(presets) -before $first -side $s -fill y
+        pack $itk_component(presets) -before $itk_component(value) \
+            -side $s -fill y
 
         $itk_component(presetlist) delete 0 end
@@ -710,66 +440,2 @@
     }
 }
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -type
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Gauge::type {
-    switch -- $itk_option(-type) {
-        integer {
-            set first [lindex [pack slaves $itk_component(vframe)] 0]
-            if {$first == $itk_component(presets)} {
-                pack $itk_component(spinner) -after $first -side left -fill y
-            } else {
-                pack $itk_component(spinner) -before $first -side right -fill y
-            }
-        }
-        real {
-            pack forget $itk_component(spinner)
-        }
-        default {
-            error "bad number type \"$itk_option(-type)\": should be integer or real"
-        }
-    }
-}
-
-itcl::body Rappture::Gauge::_pop_uq {win} {
-    # puts "min=$itk_option(-minvalue) max=$itk_option(-maxvalue) units=$itk_option(-units)"
-    set varname $itk_option(-varname)
-    set popup .pop_uq_$varname
-    if { ![winfo exists $popup] } {
-        Rappture::Balloon $popup -title $itk_option(-label)
-        set inner [$popup component inner]
-        frame $inner.type
-        pack $inner.type -side top -fill x
-        label $inner.type.l -text "Parameter Value:"
-        pack $inner.type.l -side left
-
-        set _val [Rappture::Combobox $inner.type.val -width 20 -editable no]
-        pack $_val -side left -expand yes -fill x
-        $_val choices insert end exact "Exact Value"
-        $_val choices insert end uniform "Uniform Distribution"
-        $_val choices insert end gaussian "Gaussian Distribution"
-        bind $_val <<Value>> [itcl::code $this _change_param_type $inner]
-
-        set _pde [Rappture::ProbDistEditor $inner.entry \
-        $itk_option(-minvalue) $itk_option(-maxvalue) $itk_option(-units) $_value]
-        $_val value $_mode
-        $_pde value $_value
-        pack $inner.entry -expand yes -fill both -pady {10 0}
-
-        $popup configure \
-            -deactivatecommand [itcl::code $this _pop_uq_deactivate]
-    }
-    update
-    $popup activate $win right
-}
-
-itcl::body Rappture::Gauge::_pop_uq_deactivate {} {
-    # puts "deactivate [$_pde value]"
-    value [$_pde value]
-}
-
-itcl::body Rappture::Gauge::_change_param_type {inner} {
-    set val [$_val translate [$_val value]]
-    $_pde mode $val
-}
